#include "common.h"

using namespace MaskTools::Picture;

namespace MaskTools { namespace Avs25 {

CPlane PVFToConstPlane(const PVideoFrame &frame, int nPlane)
{
   return frame ? CPlane(frame->GetReadPtr(nPlane), frame->GetPitch(nPlane)) : CPlane();
}

Plane PVFToPlane(const PVideoFrame &frame, int nPlane)
{
   return frame ? Plane(frame->GetWritePtr(nPlane), frame->GetPitch(nPlane)) : Plane();
}


CFrame PVFToConstFrame(const PVideoFrame &frame)
{
   return CFrame(PVFToConstPlane(frame, PLANAR_Y), PVFToConstPlane(frame, PLANAR_U), PVFToConstPlane(frame, PLANAR_V));
}

Frame PVFToFrame(const PVideoFrame &frame)
{
   return Frame(PVFToPlane(frame, PLANAR_Y), PVFToPlane(frame, PLANAR_U), PVFToPlane(frame, PLANAR_V));
}

} }
