#ifndef __Mt_Invert_H__
#define __Mt_Invert_H__

#include "../../common/base/filter.h"

namespace MaskTools { namespace Filters { namespace Invert {

typedef void(Processor)(Byte *pDst, int nDstPitch, int nWidth, int nHeight);

class Filter : public MaskTools::Filter
{
protected:
   virtual void ProcessY(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessU(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessV(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

public:
   Filter(const Parameters::Parameters &parameters);

   static Parameters::Signature getSignature();
   static String getName();
   static Clip::Inputs inputClips;
};

Processor invert_c;

extern "C" Processor Invert_invert8_mmx;
extern "C" Processor Invert_invert8_isse;
extern "C" Processor Invert_invert8_3dnow;

} } }

#endif