#ifndef __Mt_Lut_H__
#define __Mt_Lut_H__

#include "../../../common/base/filter.h"

namespace MaskTools { namespace Filters { namespace Lut { namespace Single {

typedef void(Processor)(Byte *pDst, int nDstPitch, int nWidth, int nHeight, const Byte lut[256]);

class Filter : public MaskTools::Filter
{
   Byte yLut[256], uLut[256], vLut[256];

protected:
   virtual void ProcessY(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessU(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessV(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

public:
   Filter(const Parameters::Parameters &parameters);

   static String getName();
   static Parameters::Signature getSignature();
   static Clip::Inputs inputClips;
};

Processor lut_c;

} } } }

#endif