// ConvertToPostfix  Copyright 2005 Tonny Petersen

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA, or visit
// http://www.gnu.org/copyleft/gpl.html .

#include "parser.h"

#include <string>
#include <sstream>
#include <stack>

using namespace std;

AVSValue __cdecl ConvertToPostfix(AVSValue args, void* user_data, IScriptEnvironment* env)
{
	const string numerics("0123456789xy");
	string input = args[0].AsString();
	string temp;
	stringstream output;
	stack<string> stringstack;
	int pos=0;
	int lastpos=pos;
	int poplast=0;
	while(string::npos!=(pos=input.find_first_of(' ',lastpos))){
	temp = input.substr(lastpos,pos-lastpos);
	lastpos=pos+1;
	//find right parenthesis
	while(string::npos !=(pos=temp.find(')'))){
		poplast++;
		temp.erase(pos,1);
	}
	//delete spaces and left paranthesis
	while(string::npos !=(pos=temp.find_first_of("( "))){
	temp.erase(pos,1);
	}

	//if number output it 
    if(string::npos != (numerics.find_first_of(temp)) )
	{
		if(string::npos != temp.find_first_of("xy")&&temp.length()>1)
			stringstack.push(temp);
		else
		{
			output<<temp<<" ";
		}
	}
	//else push it
	else
		stringstack.push(temp);
	//pop from stack
	while(poplast)
	{
		poplast--;
		output<<stringstack.top()<<" ";
		stringstack.pop();
	}
	}
	
	temp = input.substr(lastpos,input.length()-lastpos);
	//find right parenthesis
	while(string::npos !=(pos=temp.find(')'))){
		poplast++;
		temp.erase(pos,1);
	}
	//delete spaces and left paranthesis
	while(string::npos !=(pos=temp.find_first_of("( "))){
	temp.erase(pos,1);
	}

	//if number output it 
    if(string::npos != (numerics.find_first_of(temp)) )
	{
		if(string::npos != temp.find_first_of("xy")&&temp.length()>1)
			stringstack.push(temp);
		else
		{
			output<<temp;
			if(stringstack.size()>0)
				output<<" ";
		}
	}
	//else push it
	else
		stringstack.push(temp);
	//pop all operators from stack
	while(stringstack.size())
	{
		poplast--;
		output<<stringstack.top();
		if(stringstack.size()>1)
			output<<" ";
		stringstack.pop();
	}
	input=output.str();
	return env->SaveString(input.c_str(),input.length());
}