#include "softwire.h"

using namespace SoftWire;

namespace MaskTools { namespace SoftWire {

static void loadHeightPixelsPad1Left(DynamicGenerator &x86, LoadInstruction load, const ::SoftWire::OperandMMREG &dest,
                                const ::SoftWire::OperandREF &address, const ::SoftWire::OperandMMREG &junk1,
                                const ::SoftWire::OperandMMREG &junk2)
{
}

void loadHeightPixels(DynamicGenerator &x86, LoadInstruction load, const ::SoftWire::OperandMMREG &dest, 
                      const ::SoftWire::OperandREF &address, const ::SoftWire::OperandMMREG &junk1,
                      const ::SoftWire::OperandMMREG &junk2, int nX, int nWidth)
{
   if ( nX < 0 )
   {
      x86.movq(dest, Assembler::qword_ptr[address - nX]);
      if ( nX == -2 )
      {
      }

   }
   else if ( nX + 8 > nWidth )
   {
   }
   else
   {
      (x86.*load)(dest, Assembler::qword_ptr[address]);
   }
}

/* One line */

int Lines1::stack_size() const
{
   return 0; /* no need for extra variable on the stack */
}

void Lines1::prologue(int nStackOffset, int nPtrDisp, int nPitchDisp)
{
   x86.mov(oPtr, dword_ptr [esp + nPtrDisp]);
   x86.mov(oPitch, dword_ptr [esp + nPitchDisp]);
}

void Lines1::epilogue()
{
   /* nothing to do */
}

void Lines1::nextLine()
{
   x86.add(oPtr, oPitch);
   nY++;
   nX = 0;
}

void Lines1::nextPixels(int nStride)
{
   /* nothing to do */
   nX += nStride;
}

void Lines1::loadHeightPixels(int nX, int nY, const ::SoftWire::OperandREG32 &oHorOffset, LoadInstruction load,
                              const ::SoftWire::OperandMMREG &dest, const ::SoftWire::OperandMMREG &junk1,
                              const ::SoftWire::OperandMMREG &junk2) const
{
   MaskTools::SoftWire::loadHeightPixels(x86, load, dest, oPtr + oHorOffset + nX, junk1, junk2, nX + this->nX, nWidth);
}

/* 3 lines */

int Lines3::stack_size() const
{
   return 4; /* need to save the offset to jump to the next line */
}

void Lines3::prologue(int nStackDisp, int nPtrDisp, int nPitchDisp)
{
   x86.mov(oPtr, dword_ptr [esp + nPtrDisp]);
   x86.mov(oPitch, dword_ptr [esp + nPitchDisp]);
   x86.mov(eax, oPitch);
   x86.sub(eax, nWidth);
   nJumpDisp = nStackDisp;
   x86.mov(dword_ptr[esp + nJumpDisp], eax); /* jump offset */
}

void Lines3::epilogue()
{
   /* nothing to do */
}

void Lines3::nextLine()
{
   if ( nY )
      x86.add(oPtr, dword_ptr[esp + nJumpDisp]);
   nY++;
   nX = 0;
}

void Lines3::nextPixels(int nStride)
{
   x86.add(oPtr, nStride);
   nX += nStride;
}

void Lines3::loadHeightPixels(int nX, int nY, const ::SoftWire::OperandREG32 &oHorOffset, LoadInstruction load,
                              const ::SoftWire::OperandMMREG &dest, const ::SoftWire::OperandMMREG &junk1,
                              const ::SoftWire::OperandMMREG &junk2) const
{
   OperandREF address;

   if ( nY + this->nY < 0 ) address = oPtr + nX;
   else if ( nY + this->nY >= nHeight ) address = oPtr + oPitch + nX;
   else oPtr + (nY + 1) * oPitch + nX;

   MaskTools::SoftWire::loadHeightPixels(x86, load, dest, address, junk1, junk2, nX + this->nX, nWidth);
}

void Test()
{
}

} }